
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>封装stream，在读写stream时提供事件通知 / iVAN</title>

    <meta name="description" content="封装stream，在读写stream时提供事件通知 前阵子的工作涉及一些网络编程,使用了面向流的方式做传输数据.在代码过程中,遇到一个新需求就是要统计流量.其实最简单的办法就时在读写流的地方增加代码,把功能增加上去就可以.但是我觉得那样对我原理的代码框架影响较大,基于尽量不影响原来的代码的考虑,我想到了Decorator设计模式. 先把代码贴出来,在做解释吧:     以下为引用的内容: public class EventStream : Stream    {        public event EventHandler&lt;FStre ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">封装stream，在读写stream时提供事件通知</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>前阵子的工作涉及一些网络编程，使用了面向流的方式做传输数据。在代码过程中，遇到一个新需求就是要统计流量。其实最简单的办法就时在读写流的地方增加代码，把功能增加上去就可以。但是我觉得那样对我原理的代码框架影响较大，基于尽量不影响原来的代码的考虑，我想到了Decorator设计模式。</p>
<p>先把代码贴出来，在做解释吧：</p>
<p>   </p>
<table>
<tr>
<td>
以下为引用的内容：<br /> public class EventStream : Stream<br />    {<br />        public event EventHandler&lt;FStreamDataEventArgs&gt; OnBeforeRead;<br />        public event EventHandler&lt;FStreamDataEventArgs&gt; OnBeforeWrite;            <br />        private Stream stream;<br />        public EventStream(Stream stream)<br />        {<br />            if (stream == null) throw new ArgumentNullException("EventStream");  <br />            this.stream = stream;<br />        }</p>
<p>        [ ==== Stream members ==== ]#region [ ==== Stream members ==== ]<br />        public override bool CanRead<br />        {<br />            get { return stream.CanRead; }<br />        }</p>
<p>        public override bool CanSeek<br />        {<br />            get { return stream.CanSeek; }<br />        }</p>
<p>        public override bool CanWrite<br />        {<br />            get { return stream.CanWrite; }<br />        }</p>
<p>        public override void Flush()<br />        {<br />            stream.Flush();<br />        }</p>
<p>        public override long Length<br />        {<br />            get { return stream.Length; }<br />        }</p>
<p>        public override long Position<br />        {<br />            get<br />            {<br />                return stream.Position;<br />            }<br />            set<br />            {<br />                stream.Position = value;<br />            }<br />        }</p>
<p>        public override int Read(byte[] buffer, int offset, int count)<br />        {<br />            int readSize = stream.Read(buffer, offset, count);<br />            if (OnBeforeRead != null)<br />                OnBeforeRead(this, new FStreamDataEventArgs(buffer, offset, readSize));<br />            return readSize;<br />        }</p>
<p>        public override long Seek(long offset, SeekOrigin origin)<br />        {<br />            return stream.Seek(offset, origin);<br />        }</p>
<p>        public override void SetLength(long value)<br />        {<br />            stream.SetLength(value);<br />        }</p>
<p>        public override void Write(byte[] buffer, int offset, int count)<br />        {<br />            if (OnBeforeWrite != null)<br />                OnBeforeWrite(this, new FStreamDataEventArgs(buffer, offset, count));<br />            stream.Write(buffer, offset, count);<br />        }</p>
<p>        public override IAsyncResult BeginRead(byte[] buffer, int offset, int count, <br />            AsyncCallback callback, object state)<br />        {<br />            InternalAsyncState myState = new InternalAsyncState(<br />                              new FStreamDataEventArgs(buffer, offset, count), state);<br />            AsyncCallback myCallback = new AsyncCallback(<br />                              new InternalCallback(OnBeforeRead, callback).Callback);<br />            return new EventStreamAsyncResult(  <br />                                 stream.BeginRead(buffer, offset, count, myCallback, myState));<br />        }</p>
<p>        public override int EndRead(IAsyncResult asyncResult)<br />        {<br />            EventStreamAsyncResult esar = asyncResult as EventStreamAsyncResult;<br />            if (esar != null)<br />                return stream.EndRead(esar.InternalAsyncResult);<br />            else<br />                return stream.EndRead(asyncResult);<br />        }</p>
<p>        public override IAsyncResult BeginWrite(byte[] buffer, int offset, int count, AsyncCallback callback, object state)<br />        {<br />            InternalAsyncState myState = new InternalAsyncState(<br />                              new FStreamDataEventArgs(buffer, offset, count), state);<br />            AsyncCallback myCallback = new AsyncCallback(<br />                              new InternalCallback(OnBeforeWrite, callback).Callback);<br />            return new EventStreamAsyncResult(  <br />                              stream.BeginWrite(buffer, offset, count, myCallback, myState));<br />        }</p>
<p>        public override void EndWrite(IAsyncResult asyncResult)<br />        {<br />            stream.EndWrite(asyncResult);<br />        }</p>
<p>        #endregion</p>
<p>        private class InternalCallback<br />        {<br />            private AsyncCallback callback;<br />            private EventHandler&lt;FStreamDataEventArgs&gt; internalHandler;</p>
<p>            public InternalCallback(EventHandler&lt;FStreamDataEventArgs&gt; internalHandler, AsyncCallback callback)<br />            {<br />                this.internalHandler = internalHandler;<br />                this.callback = callback;<br />            }</p>
<p>            internal void Callback(IAsyncResult asyncResult)<br />            {<br />                InternalAsyncState myState = asyncResult.AsyncState as InternalAsyncState;<br />                if (internalHandler != null &amp;&amp; myState != null)<br />                    internalHandler(this, myState.StreamDataEventArgs);<br />                callback(new EventStreamAsyncResult(asyncResult));<br />            }<br />        }</p>
<p>        private class InternalAsyncState<br />        {<br />            object state;<br />            FStreamDataEventArgs streamDataEventArgs;</p>
<p>            public object State<br />            {<br />                get { return state; }<br />            }</p>
<p>            public FStreamDataEventArgs StreamDataEventArgs<br />            {<br />                get { return streamDataEventArgs; }<br />            }</p>
<p>            public InternalAsyncState(FStreamDataEventArgs streamDataEventArgs, object state)<br />            {<br />                this.streamDataEventArgs = streamDataEventArgs;<br />                this.state = state;<br />            }<br />        }</p>
<p>        private class EventStreamAsyncResult : IAsyncResult<br />        {<br />            IAsyncResult ar;</p>
<p>            public EventStreamAsyncResult(IAsyncResult ar)<br />            {<br />                if (ar == null) throw new ArgumentNullException("EventStreamAsyncResult");<br />                this.ar = ar;<br />            }<br />            IAsyncResult Members#region IAsyncResult Members</p>
<p>            public object AsyncState<br />            {<br />                get<br />                {<br />                    InternalAsyncState myState = ar.AsyncState as InternalAsyncState;<br />                    if (myState != null)<br />                        return myState.State;<br />                    else<br />                        return ar.AsyncState;  <br />                }<br />            }</p>
<p>            internal IAsyncResult InternalAsyncResult<br />            {<br />                get { return ar; }<br />            }</p>
<p>            public System.Threading.WaitHandle AsyncWaitHandle<br />            {<br />                get { return ar.AsyncWaitHandle; }<br />            }</p>
<p>            public bool CompletedSynchronously<br />            {<br />                get { return ar.CompletedSynchronously; }<br />            }</p>
<p>            public bool IsCompleted<br />            {<br />                get { return ar.IsCompleted; }<br />            }</p>
<p>            #endregion<br />        }<br />    }</p>
<p>    public class FStreamDataEventArgs : EventArgs<br />    {<br />        private byte[] buffer;<br />        private int offset;<br />        private int count;</p>
<p>        public FStreamDataEventArgs(byte[] buffer, int offset, int count)<br />        {<br />            if(buffer == null) throw new ArgumentNullException("FStreamDataEventArgs");<br />            if(offset + count&gt;buffer.Length) throw new ArgumentOutOfRangeException("FStreamDataEventArgs");</p>
<p>            this.buffer = buffer;<br />            this.offset = offset;<br />            this.count = count;<br />        }</p>
<p>        /**//// &lt;summary&gt;<br />        /// 数据缓存<br />        /// &lt;/summary&gt;<br />        public byte[] Buffer<br />        {<br />          get { return buffer; }<br />        }</p>
<p>        /**//// &lt;summary&gt;<br />        /// 数据开始位置<br />        /// &lt;/summary&gt;<br />        public int Offset<br />        {<br />          get { return offset; }<br />        }</p>
<p>        /**//// &lt;summary&gt;<br />        /// 数据长度<br />        /// &lt;/summary&gt;<br />        public int Count<br />        {<br />          get { return count; }<br />        }<br />    }</p>
</td>
</tr>
</table>
<p>刚开始以为很简单，事实上写下来还挺多行代码的，Decorator模式嘛，当然先继承stream，把stream本来该做的事情先完成了。这个很简单类里面包含一个内部的stream，stream该有的接口都由它来完成了。接下来就是增加两个事件，分别是OnBeforeRead、OnBeforeWrite。名字里面都有Before，其实我考虑到数据流都会通过这两个事件开放出来，你想做加密什么的都可以，当然也包括我想要的统计数据流量。</p>
<p>接下来就是在读写流的时候触发这两个事件就可以了。看看同步的Read、Write方法，简单的调用就可以了。<br />关键的地方就在于异步的读写。</p>
<p>我们先看看一般Stream的异步调用代码是怎么样的：</p>
<table>
<tr>
<td>
以下为引用的内容：</p>
<p>stream.BeginRead(buffer, 0, byte2read, new AsyncCallback(EndReadCallback), state);</p>
<p>private void EndReadCallback(IAsyncResult asyncResult)<br />{<br />    object state = asyncResult.AsyncState;<br />    nReadSize = stream.EndRead(asyncResult);<br />            //<br />}</p>
</td>
</tr>
</table>
<p>在不更改这个“client”代码的情况下，要怎么样在stream那边知道这里的确实读了多少数据呢？</p>
<p>显然在调用BeginRead的时候是不知道，那就只能对这个AsyncCallback做手脚了。可以预想到framework内部会在完成了Read的操作之后会调用AsyncCallback委托来通知结果。于是我就传一个我定义好的AsyncCallback委托给BeginRead。当然还要把“client”提供的AsyncCallback给包装起来，在做完我的事情(事件通知)之后，还是要把“client”要我办的事情给也给办了(调用"client"的AsyncCallback委托来通知结果)。</p>
<p>这就在实现了“在客户代码与framework之间插一脚”。</p>
<p>再来看看我是怎么做到事件通知的。首先要把我要的数据给传过去，于是有了InternalAsyncState，这里面要有我触发事件需要的事件参数，还应该要包括用户可能传入的state。具体大家看看InternalAsyncState的实现。</p>
<p>最后多考虑了一点就是，假如“client”代码不是像我写的那样，而是不断的通过检查Stream.BeginRead 方法返回的IAsyncResult的IsCompleted属性来确定是否Read完成的话，那我的代码就有问题了，我返回的IAsyncResult根本就不是原理的IAsyncResult了。EventStreamAsyncResult类就是为这个而写的。<br />下面是使用的代码：</p>
<table>
<tr>
<td>
以下为引用的内容：<br />public void GetResponseStream()<br />{<br />        EventStream es = new EventStream(tcpClient.NetStream);<br />        es.OnBeforeRead += new EventHandler&lt;FStreamDataEventArgs&gt;(EventStream_OnBeforeRead);<br />        es.OnBeforeWrite += new EventHandler&lt;FStreamDataEventArgs&gt;(EventStream_OnBeforeWrite);<br />        return es;<br />}</td>
</tr>
</table>
<p>回头看看代码，其实都在用Decorator模式的思想，把原来的framework中的类都给包装起来，并在完成原来的功能之余另外加了自己的功能。</p>
<p>文笔一般，希望能对你有帮助。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 03:37:48</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/public/" title="public">public</a>, <a href="https://www.iamivan.net/tag/return/" title="return">return</a>, <a href="https://www.iamivan.net/tag/stream/" title="stream">stream</a>, <a href="https://www.iamivan.net/tag/buffer/" title="buffer">buffer</a>, <a href="https://www.iamivan.net/tag/iasyncresult/" title="IAsyncResult">IAsyncResult</a>, <a href="https://www.iamivan.net/tag/iasyncresult%c2%a0/" title="IAsyncResult&nbsp;">IAsyncResult&nbsp;</a>, <a href="https://www.iamivan.net/tag/es-java-client/" title="es java client">es java client</a>, <a href="https://www.iamivan.net/tag/offset/" title="offset">offset</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>封装stream，在读写stream时提供事件通知的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPBNwlb.html" rel="bookmark">easyui-用户登陆按Enter提交时&comma;keydown事件覆盖了&dollar;&period;messager&period;alert&lpar;&rpar;弹出框</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 用户登陆按Enter提交时,keydown事件覆盖了$.messager.alert()弹出框 在用户登陆界面中,在页面初始化时,添加键盘事件: $(function() { $(document).keydown(function(e){ if(e.keyCode == 13){ login(); } }); }); function login(){ $.ajax();发送请求在回调函数中调用easyui提供的 $.messager.alert('登录提示', '用户名不存在!',			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRdxJqz.html" rel="bookmark">js实现浏览器窗口大小被改变时触发事件的方法&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了js实现浏览器窗口大小被改变时触发事件的方法.分享给大家供大家参考.具体分析如下: 当浏览器的窗口大小被改变时触发的事件window.onresize 为事件指定代码: 复制代码 代码如下: window.onresize = function(){ } 例如: 浏览器可见区域信息: 复制代码 代码如下: &lt;span id=&quot;info_jb51_net&quot;&gt;请改变浏览器窗口大小&lt;/span&gt; &lt;script&gt; window.onresiz			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/5zOWx3z.html" rel="bookmark">winforms-VB&period;net下如何实现鼠标进入窗体某区域时触发事件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 VB.net下如何实现鼠标进入窗体某区域时触发事件 VB.net Winforms开发form上有一个mediaplayer控件,在上面设置一个隐藏的(visible=false)按钮如何实现鼠标进入按钮附近区域时触发button1.visible=true的事件 因为按钮是在mediaplayer之上的,所以之前尝试的画Rectangle来检测鼠标位置的方法不行 想来想去只有通过PointToClient的方法实现,但是不知道具体怎么操作 求教,谢谢			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKkJKAb.html" rel="bookmark">xcode-点击自定义按钮时触发事件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 点击自定义按钮时触发事件 创建了一个TableView,然后创建了自定义的单元,其中放了一个Button.现在我想要实现,点击索引的时候获取tableview的索引内容,但是点击了对应索引的按钮之后,没有给出索引列表. 我的tableview类名是SubMenuViewController,然后单元类名是SubMenuCell, SubMenuViewController代码如下: - (UITableViewCell *)tableView:(UITableView *)tableV			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlBeYDz.html" rel="bookmark">gtk&plus;程序在关闭主窗口时的事件流</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当鼠标单击gtk+窗口的关闭按钮时,程序首先接收到delete_event,当该事件处理函数返回TRUE表示事件已处理禁止进一步传播,从而取消关闭操作:当返回FALSE时,事件消息进一步向上传播,此时会调用gtk+默认的处理函数,该函数产生destroy事件,一般在该事件的处理函数中用gtk_main_quit将窗口关闭:这时gtk_main()消息环退出,因而程序退出. 下面是示例代码: #include &lt;gnome.h&gt; gboolean delete_handle(GtkWidget			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwWlGWz.html" rel="bookmark">flex 监听事件-flex中的datefield组件中点击下拉选择日期改变时派发事件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 flex中的datefield组件中点击下拉选择日期改变时派发事件 如题,我需要在选择日期时监听change事件,执行脚本,但是为什么每次会执行两次脚本. 怎么可以控制只在选择日期之后派发,而在点击时不派发. /** 添加监听事件 / this.addEventListener(CalendarLayoutChangeEvent.CHANGE, selectedChange); /* 对象更改处理函数 */ protected function selectedChange(event			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZgdA6b.html" rel="bookmark">点击label时click事件被触发两次的坑</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:点击label时click事件被触发两次的坑 今天帮群里的朋友看一段代码的时候偶然间遇到一个label的坑,点击label的时候,监听的click事件被执行两次: 具体代码如下: 1 &lt;div id=&quot;test&quot;&gt; 2 &lt;input type=&quot;checkbox&quot; name=&quot;abc&quot; id=&quot;abc&quot;/&gt; 3 &lt;label for=&quot;abc&quot;&gt;3423432432			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnR3x0p.html" rel="bookmark">easyui Enter提交时&comma;keydown事件覆盖了&dollar;&period;messager&period;alert&lpar;&rpar;弹出框</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 easyui Enter提交时,keydown事件覆盖了$.messager.alert()弹出框 easyui Enter键提交查询条件,如果日期不符合条件,弹出提示框,但是弹出框弹不出来 ,应该怎么解决,代码如下: /*查询方法 */ function queryData(){ var beginDate = $(&quot;#createStartDate&quot;).datebox(&quot;getValue&quot;); var endDate = $(&quot;#create			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkZ9eEM.html" rel="bookmark">java fatjar-eclipse生成的fatjar在别的电脑上运行时按钮事件无法响应</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 eclipse生成的fatjar在别的电脑上运行时按钮事件无法响应 在自己电脑上运行正常,在别的电脑上只能弹出最初的界面,点击界面上的按钮无法弹出相应的面板,求大神们帮忙看看			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9Xovb.html" rel="bookmark" class="title">&lbrack;W3C标准&rsqb;一个完美网站的101项指标之七</a>
					<div>
						网站|w3c标准 符合 W3C 标准是网站的发展趋势,目前,几乎所有的浏览器都使用 W3C 标准,W3C 标准保证您的网站在所有主流浏览器中都获得一致的表现,您再也不需要象90年代末那样,向不同的浏览 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8Jnxb.html" rel="bookmark" class="title">关注个人网站的发展&mdash;图王章征军专访</a>
					<div>
						个人网站 认识图王,是在06华南地区站长交流大会上.以前经常能在网络上看到有关图王的介绍,总以为图王是一个很正经.很严肃的主儿,所以在大会上发言的时候,我怎么也想象不到眼前这个和善.身体略显发福的人就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zG57lM.html" rel="bookmark" class="title">口碑营销给博客、网站、商家带来三赢</a>
					<div>
						一个网站不谈赢利是很不现实的一件事情,就像一个人一样,要想生存下去,你必须要先吃饭.而对网站来说也是如此,你想运作下去,必须要有经济来源,除非在现实中你有花不完的钱,像比尔盖茨一样每妙以几千美元的流入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKJrap.html" rel="bookmark" class="title">C&num;开发WPF&sol;Silverlight动画及游戏系列教程&lpar;Game Course&rpar;：&lpar;十二&rpar;</a>
					<div>
						C#开发WPF/Silverlight动画及游戏系列教程(Game Course):(十二)神奇的副本地图 前面几节详细的讲解了游戏地图的完整构造,比较有难度的是关于地图内层如障碍物的实现.A*算法往 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPN2lrb.html" rel="bookmark" class="title">MySQL中Order By实现原理分析</a>
					<div>
						下面将通过实例分析两种排序实现方式及实现图解: 假设有 Table A 和 B 两个表结构分别如下: 1 sky@localhost : example 01:48:21&gt; show creat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKEy8p.html" rel="bookmark" class="title">在Word 2010中禁用硬件图形加速</a>
					<div>
						Word 2010软件具有支持硬件图形加速的功能,从而可以提升图形图像在Word 2010软件中的显示效果.用户可以根据需要启用或禁用硬件图形加速功能,操作 步骤如下所述: 第1步,打开Word 20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2vJZp.html" rel="bookmark" class="title">Oracle RAC OCR 备份与恢复概述</a>
					<div>
						Oracle Clusterware把整个集群的配置信息放在共享存储上,这些信息包括了集群节点的列表.集群数据库实例到节点的映射以及CRS应用程序资源信息.也即是存放在ocr 磁盘(或者ocfs文件) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGje8np.html" rel="bookmark" class="title">利用Java开发Web应用（二） 服务器端的实现</a>
					<div>
						在服务器端,如果用 Java 语言实现的话,直接与浏览器打交道的要算JavaServer Pages(JSPs)和Servlets了.在它们的后面还有通过Java实现的Data Beans.DB Be ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Pd4nM.html" rel="bookmark" class="title">Fireworks如何制作炫光效果</a>
					<div>
						  1.新建画布600×400,填充黑色设置画笔大小,柔化边缘,用画笔工具在画布中涂画. 2.对刚才的图形做运动模糊,设置角度90,距离100,平面化刚才的图形. 3.新建矩形框,填充渐变,图层模式为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6Y6Xz.html" rel="bookmark" class="title">HTML5新特性介绍</a>
					<div>
						HTML基本思维概念形成于2003年,之后W3C对页面超文本应用技术工作小组(WHATWG)开发的HTML草图颇感兴趣,这个小组的开发人员均来自Apple ,Mozilla,和Opera.2007年W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7krZdz.html" rel="bookmark" class="title">快车&OpenCurlyDoubleQuote;任务管理&rdquo;如何分类规则设置</a>
					<div>
						快车&quot;基本设置&quot;的分类规则设置说明如下: 默认分类规则的对应关系,此处仅对已存在的分类设置规则. 系统相关 1.不同扩展名请用空格分开. 2.其他扩展名的文件将自动归入&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN17JJb.html" rel="bookmark" class="title">Photoshop调出美女照片甜美的橙黄色效果</a>
					<div>
						效果图用到的颜色比较少,仅有橙黄色及暗青色.调色过程也比较简单,只需要把中间调及高光部分的颜色转为暖色,暗部增加一些冷色即可. photoshop教程原图 &lt;点小图查看大图&gt; 最终效果 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1EDOKM.html" rel="bookmark" class="title">word2007重排或移动形状间的连接线</a>
					<div>
						  连接线是一种线条,它连接两个形状并保持连接到它所连接的形状.有三种类型的连接线:直线形.肘形(带角度的)和曲线形.连接点位于连接线的两端,当您在一个形状上移动鼠标指针时,另一种连接点将以圆点的形式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badwY2z.html" rel="bookmark" class="title">PetaPoco支持Dynamic（ExpandoObject）类型参数</a>
					<div>
						修改ParametersHelper类,添加ExpandoObject的类型判断吧,修改后的代码如下: // PetaPoco - A Tiny ORMish thing for your POCO' ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NoRAz.html" rel="bookmark" class="title">客户端访问服务端时，通过ELB；ELB主动关闭第一次请求的源端口，导致后端反馈信息没法通信&quest;</a>
					<div>
						问题描述 客户端访问服务端时,通过ELB:ELB主动关闭第一次请求的源端口,导致后端反馈信息没法通信?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrx1GM.html" rel="bookmark" class="title">请教sql server2008如何远程连接informix数据库？</a>
					<div>
						问题描述 请教sql server2008如何远程连接informix数据库? 刚自学的小白,求大神解答: 如题 远程主机:192.168.1.110 端口:8691 实例名:ppsvr 数据库:pp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvry18M.html" rel="bookmark" class="title">【技术辟谣】Facebook机器人发明语言系误读，专家访谈还原真相</a>
					<div>
						最近 Facebook 的一个 AI 项目火了,而且火得不要太好--稍微上网一搜就能看到: AI 机器人发展出自己的语言,Facebook 的工程师们慌了 Facebook AI 发明出人类不能理解的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmw5Az.html" rel="bookmark" class="title">java-各位大大留步指教一下关于溢出的问题。</a>
					<div>
						问题描述 各位大大留步指教一下关于溢出的问题. 大家好,我是一个新手,所以提的问题可能太弱智了一点,但请各位大牛详细指教一下,不胜感激. 众所周知,F(此处16个F)=-1 , 我也知道这是补码.然后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQXynz.html" rel="bookmark" class="title">cmd-java&period;util&period;Scanner输入问题</a>
					<div>
						问题描述 java.util.Scanner输入问题 刚学java,老师布置了作业让求一元二次方程的根,直接在txt中编的,然后再cmd运行.编了一个程序编译通过了,但是输了三个数结果出不来,求教!我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOm3DmM.html" rel="bookmark" class="title">网龙刘路远：代理模式对中国网游业功不可没</a>
					<div>
						7月17日凌晨消息,本土网游企业网龙行政总裁刘路远向新浪科技表示,代理模式对中国网游业的开拓与发展功不可没,不过自主研发扮演着越来越重要的角色.他认为,公司创办以来最满意的事情是成功上市,而最遗憾的则 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4Wooz.html" rel="bookmark" class="title">ubuntu14&period;04环境下安装配置caffe，最后编译caffe时出错</a>
					<div>
						问题描述 ubuntu14.04环境下安装配置caffe,最后编译caffe时出错 我按照http://www.linuxdiyf.com/linux/13008.html 这篇博客配置caffe,前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7xa2p.html" rel="bookmark" class="title">文件上传类</a>
					<div>
						class yl_upload_class { #********************************************************* #创建目录函数 #******** ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKNQ6b.html" rel="bookmark" class="title">《电子元器件的可靠性》&mdash;&mdash;3&period;1节可靠性试验的意义</a>
					<div>
						3.1 可靠性试验的意义3.1.1 可靠性试验的目的与内容 可靠性试验是评价产品可靠性水平的重要手段.目前把测定.验证.评价.分析等为提高产品可靠性而进行的各种试验,统称为可靠性试验.可靠性试验是开展 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bod4j3M.html" rel="bookmark" class="title">电子商务业务模式的利弊讨论，一直存在所谓优劣之争</a>
					<div>
						在国内电子商务业务模式的利弊讨论中,一直存在着所谓综合门户与垂直门户的优劣之争,是大而全还是专而精,各方意见莫衷一是.国内电子商务的迅猛发展,特别是受中国化工网.中国服装网.家纺人等行业垂直门户崛起的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAkrdb.html" rel="bookmark" class="title">mfc-Unicode 动态库LoadLibrary加载慢</a>
					<div>
						问题描述 Unicode 动态库LoadLibrary加载慢 各位大虾, 我写了个Unicode MFC DLL,用LoadLibrary加载很慢.怎么解决这个问题? 解决方案 试试看静态加载dll能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlL8NDM.html" rel="bookmark" class="title">《Node&period;js入门经典》一1&period;4　小结</a>
					<div>
						1.4 小结 Node.js入门经典 好极了!你刚刚创建并运行了第一个Node.js程序.虽然你现在不太可能以Internet百万富翁的身份退休,但以这个简单的示例为基础,在将来的几章里你将可以创建出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxEOnGp.html" rel="bookmark" class="title">ASP&period;NET&lpar;C&num;&rpar;读取Excel的文件内容&lowbar;实用技巧</a>
					<div>
						.xls格式       Office2003及以下版本 .xlsx格式 Office2007 及以上版本 .csv格式       以逗号分隔的字符串文本(可以将上述两种文件类型另存为此格式) 读取 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmyNVp.html" rel="bookmark" class="title">【超高效开发之道】 VS&period;NET 最佳开发伴侣 Deklarit 4&period;5 for VS2008</a>
					<div>
						问题描述 Deklarit连续三年被.NETDJ评为最佳VS.NETCG工具!Deklarit将VisualStudio.NET变成一个数据.业务层RAD工具.它整合入VisualStudio.NET ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyK3w8z.html" rel="bookmark" class="title">3G从建设转向运营：终端和增值业务是关键</a>
					<div>
						时尚多变的3G终端和丰富多彩的增值业务内容将成为三大运营商吸引消费者的制胜法宝 江怡曼 拥挤的公交车上,手里仅仅是一只手机,就能看新闻.听音乐.玩游戏.播视频.下电影.上开心网,内容丰富到令你目不暇接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mqgl8Zz.html" rel="bookmark" class="title">腾讯B2C平台将上线</a>
					<div>
						中国互联网中的大鳄腾讯想要扩张的心十分明显了.在九月份,腾讯B2C电子商务平台会内部测试,年底前会准备上线. 现在,B2C平台是很多互联网大公司的试水选择,和销售自有品牌的网上商城不同,和自采自销的传 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
